Personal tools
You are here: Home Forum Use Error: Assertion `noveau > -1' failed.

Error: Assertion `noveau > -1' failed.

Up to Use

Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at October 09. 2021

Hi,

I've a case with spheres inside the cylinder. These spheres should be grouped according to the H level. I've done this and I meshed the geometry without an error. After importing the mesh to openFoam with "ideasUnvToFoam" some groups were detected as faceZone but these should be patches. Also  there are a lot of undefined faces but I 'm sure I defined every faces as a part of a group. Eventually ideasUnvToFoam gave error. I researched the error and it was due to some faces being shared. With a python scripts I checked all faces in groups but they are not duplicated so an ID is only used once. Without grouping I haven't such an error. For quick peek:

  • 6: H_spheres_4 is patch
  • 7: H_spheres_5 is faceZone
  • 8: H_spheres_6 is faceZone
  • 9: H_spheres_7 is patch
  • 10: H_spheres_8 is patch
  • --> FOAM Warning :
        From Foam::polyMesh::polyMesh(const Foam::IOobject&, Foam::pointField&&, const cellShapeList&, const faceListList&, const wordList&, const wordList&, const Foam::word&, const Foam::word&, const wordList&, bool)
        in file meshes/polyMesh/polyMeshFromShapeMesh.C at line 645
        Found 330746 undefined faces in mesh; adding to default patch defaultFaces
    Adding cell and face zones
     Face Zone H_spheres_6     99223
    ideasUnvToFoam: ideasUnvToFoam.C:1262: int main(int, char**): Assertion `noveau > -1' failed.
File is attached. Any suggestions are appreciated.

Kind regards,
Said.
Attachments

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at October 13. 2021

Hi,

I tried the same thing by making the spheres just a single group.The result did not change, it gave the same error. Does this indicate that the error is due to geometry? Because when I don't do any grouping, it doesn't give an error.

Any ideas?

Kind regards,
Said.

Attachments

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at October 13. 2021

Updates

I tried to Limit Tolerance (1e-12 to 1e-04) but it did not work. Also I tried Merge Nodes (with low tolerance)  and Merge Elements but it didn't work either. Has anyone encountered this error before? I really need some clues.

Kind regards,
Said.

Re: Error: Assertion `noveau > -1' failed.

Posted by Franco Otaola at October 19. 2021

Did you solve the geometry generation? I am quiet interest in the problem you had...

try exporting the mesh with the salome tool for exporting to openfoam. salomeToOpenFOAM might give you better results

Previously Said ÇATALBAŞ wrote:

Hi,

I've a case with spheres inside the cylinder. These spheres should be grouped according to the H level. I've done this and I meshed the geometry without an error. After importing the mesh to openFoam with "ideasUnvToFoam" some groups were detected as faceZone but these should be patches. Also  there are a lot of undefined faces but I 'm sure I defined every faces as a part of a group. Eventually ideasUnvToFoam gave error. I researched the error and it was due to some faces being shared. With a python scripts I checked all faces in groups but they are not duplicated so an ID is only used once. Without grouping I haven't such an error. For quick peek:

  • 6: H_spheres_4 is patch
  • 7: H_spheres_5 is faceZone
  • 8: H_spheres_6 is faceZone
  • 9: H_spheres_7 is patch
  • 10: H_spheres_8 is patch
  • --> FOAM Warning :
        From Foam::polyMesh::polyMesh(const Foam::IOobject&, Foam::pointField&&, const cellShapeList&, const faceListList&, const wordList&, const wordList&, const Foam::word&, const Foam::word&, const wordList&, bool)
        in file meshes/polyMesh/polyMeshFromShapeMesh.C at line 645
        Found 330746 undefined faces in mesh; adding to default patch defaultFaces
    Adding cell and face zones
     Face Zone H_spheres_6     99223
    ideasUnvToFoam: ideasUnvToFoam.C:1262: int main(int, char**): Assertion `noveau > -1' failed.
File is attached. Any suggestions are appreciated.

Kind regards,
Said.

 

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at October 19. 2021

Hi Franco,

  • ProcessShape_1 = geompy.ProcessShape(Cut_1, ["FixShape", "FixFaceSize"], ["FixShape.Tolerance3d", "FixShape.MaxTolerance3d", "FixFaceSize.Tolerance"], ["1e-12", "1e-12", "1e-12"])
  • Limit_tolerance_1 = geompy.LimitTolerance(ProcessShape_1, 1e-12)

I solved the unwanted sphere shape with ProcessShape and also Limit Tolerance did help me a lot. But grouping still not possible as you see. I'll give a shot to salomeToOpenFOAM. I'll post the results.

Kind regards,
Said.

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at October 26. 2021

Hi Franco and others facing this issue,

Finally I'm able to get true geometry. The methods I used were suggested by Mr. Vadim SANDLER, Project Manager at SALOME.

As you know, many spheres were disappearing after boolean operations. Changing this line:

  • ids_1 = geompy.GetInPlace(ProcessShape_1, geompy.MakeCompound( sphereFaces1 ), theName="H_spheres_1")
to this:
  • ids_1 = geompy.GetInPlace(ProcessShape_1, geompy.MakeCompound( sphereFaces1 ), True, theName="H_spheres_1")

solved that problem.

The other problem, "Assertion noveau > -1 failed" error occours because of my numbers (coordinates, radius, height) were too small as we discussed before. So I changed this and also I did not use boolean op. on spheres, I fused them with respect to the H levels then I group and cut them.

But now, I'm triyng to generate good mesh like, Max skewness below 0.7 and Max non-orthogonalty below 0.60. So far the results are not good. I'll update results here.

Last script is attached, free to use.

Kind regards,
Said.

 

Attachments

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at November 26. 2021

Hi again,

After trying hundereds of stuff for creating solvable mesh I found an article (Effect of particle contact point treatment on the CFD simulation of the heat transfer in packed beds - ScienceDirect) that suggest bridge structure for contact points. In this paper they discussed about method for packed-bed contact points and global methods like ovelapping or gap which I tried a lot disrupts the porosity. 

Eventually, I write a code for making bridges and it works fine but I cant fuse or partition all geometry (spheres and bridges) together. If remove extra edges on, it gives "Boolean driver failed" error but if remove extra edges off it just fuse a few bridge and others not appear on viewer even if they are in a study session.

Script attached but don't run it, it will takes hours to create structure. Any help would be much appreciated.

Bridge png: link.

Kind regards,
Said.

Attachments

Re: Error: Assertion `noveau > -1' failed.

Posted by Said ÇATALBAŞ at November 26. 2021

Quick answer from me.

Fuse spheres first and cylinders (bridges) seperatly and then fuse that two product.

Kind regards,
Said.

Powered by Ploneboard
Document Actions